Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34921)
@@ -3753,18 +7459,17 @@
     8 => {
         Name => 'ExternalFlashFlags',
-        PrintConv => { BITMASK => {
-            0 => 'Fired', #28
-            2 => 'Bounce Flash', #PH
-            4 => 'Wide Flash Adapter',
-            5 => 'Dome Diffuser', #28
-        }},
+        PrintConv => { 0 => '(none)',
+            BITMASK => {
+                0 => 'Fired', #28
+                2 => 'Bounce Flash', #PH
+                4 => 'Wide Flash Adapter',
+                5 => 'Dome Diffuser', #28
+            },
+        },
     },
     9.1 => {
         Name => 'FlashCommanderMode',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'Off',
-            0x80 => 'On',
-        },
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     9.2 => {
@@ -3912,8 +7617,5 @@
         Name => 'FlashCommanderMode',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'Off',
-            0x80 => 'On',
-        },
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     9.2 => {
@@ -3982,6 +7684,4 @@
         DataMember => 'FlashGroupBControlMode',
         RawConv => '$$self{FlashGroupBControlMode} = $val',
-        ValueConv => '$val >> 4',
-        ValueConvInv => '$val << 4',
         PrintConv => \%flashControlMode,
         SeparateTable => 'FlashControlMode',
@@ -4053,4 +7753,5 @@
 
 # Flash information for D90 and D700 (ref PH)
+# - confirmed in detail for D800 (0105) - PH
 %Image::ExifTool::Nikon::FlashInfo0103 = (
     %binaryDataAttrs,
@@ -4058,6 +7759,7 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     NOTES => q{
-        These tags are used by the D3 (firmware 2.x), D3X, D3S, D90, D300 (firmware
-        1.10), D300S, D700, D3000 and D5000.
+        These tags are used by the D3 (firmware 2.x), D3X, D3S, D4, D90, D300
+        (firmware 1.10), D300S, D600, D700, D800, D3000, D3100, D3200, D5000, D5100,
+        D5200, D7000.
     },
     # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
@@ -4094,8 +7796,5 @@
         Name => 'FlashCommanderMode',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'Off',
-            0x80 => 'On',
-        },
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     9.2 => {
@@ -4151,15 +7850,6 @@
     16 => { #28
         Name => 'FlashColorFilter',
-        PrintConv => {
-            0x00 => 'None',
-            1 => 'FL-GL1',
-            2 => 'FL-GL2',
-            9 => 'TN-A1',
-            10 => 'TN-A2',
-            65 => 'Red',
-            66 => 'Blue',
-            67 => 'Yellow',
-            68 => 'Amber',
-        },
+        SeparateTable => 1,
+        PrintConv => \%flashColorFilter,
     },
     17.1 => {
@@ -4178,6 +7868,4 @@
         DataMember => 'FlashGroupBControlMode',
         RawConv => '$$self{FlashGroupBControlMode} = $val',
-        ValueConv => '$val >> 4',
-        ValueConvInv => '$val << 4',
         PrintConv => \%flashControlMode,
         SeparateTable => 'FlashControlMode',
@@ -4192,5 +7880,5 @@
         SeparateTable => 'FlashControlMode',
     },
-    19 => [
+    0x13 => [
         {
             Name => 'FlashGroupAOutput',
@@ -4210,5 +7898,5 @@
         },
     ],
-    20 => [
+    0x14 => [
         {
             Name => 'FlashGroupBOutput',
@@ -4228,5 +7916,5 @@
         },
     ],
-    21 => [ #PH
+    0x15 => [ #PH
         {
             Name => 'FlashGroupCOutput',
@@ -4246,6 +7934,427 @@
         },
     ],
-);
-
+    0x1b => { #PH
+        Name => 'ExternalFlashCompensation',
+        Format => 'int8s',
+        Priority => 0,
+        ValueConv => '-$val/6',
+        ValueConvInv => '-6 * $val',
+        PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x1d => { #PH
+        Name => 'FlashExposureComp3',
+        Format => 'int8s',
+        # (does not include the built-in compensation for FlashType "Built-in,TTL&Comdr.")
+        Notes => 'does not include the effect of flash bracketing',
+        Priority => 0,
+        ValueConv => '-$val/6',
+        ValueConvInv => '-6 * $val',
+        PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x27 => { #PH (same as ShotInfoD800 0x4d2 but also valid for repeating flash)
+        Name => 'FlashExposureComp4',
+        Format => 'int8s',
+        Notes => 'includes the effect of flash bracketing.  Valid for repeating flash',
+        Priority => 0,
+        ValueConv => '-$val/6',
+        ValueConvInv => '-6 * $val',
+        PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    # 0x2b - related to flash power (PH, D800, 96=full,62=1/4,2=1/128)
+);
+
+# Flash information for the D7100 (ref PH)
+# (this is VERY similar to FlashInfo0107, but there are a few differences that
+#  would need to be resolved if these two definitions were to be combined)
+%Image::ExifTool::Nikon::FlashInfo0106 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    DATAMEMBER => [ 9.2, 17.1, 18.1, 18.2 ],
+    NOTES => 'These tags are used by the Df, D610, D3300, D5300, D7100 and Coolpix A.',
+    # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
+    0 => {
+        Name => 'FlashInfoVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    4 => {
+        Name => 'FlashSource',
+        PrintConv => {
+            0 => 'None',
+            1 => 'External',
+            2 => 'Internal',
+        },
+    },
+    6 => {
+        Format => 'int8u[2]',
+        Name => 'ExternalFlashFirmware',
+        SeparateTable => 'FlashFirmware',
+        PrintConv => \%flashFirmware,
+    },
+    8 => {
+        Name => 'ExternalFlashFlags',
+        PrintConv => { BITMASK => {
+            0 => 'Fired',
+            2 => 'Bounce Flash',
+            4 => 'Wide Flash Adapter',
+            5 => 'Dome Diffuser', # (NC, not true for the SB-910 anyway)
+          # 7 - ? (set for SB-910 when an advanced option is used, eg. diff pattern)
+        }},
+    },
+    9.1 => { # (NC)
+        Name => 'FlashCommanderMode',
+        Mask => 0x80,
+        PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+    9.2 => {
+        Name => 'FlashControlMode',
+        Mask => 0x7f,
+        DataMember => 'FlashControlMode',
+        RawConv => '$$self{FlashControlMode} = $val',
+        PrintConv => \%flashControlMode,
+        SeparateTable => 'FlashControlMode',
+    },
+  # 10 - similar to 0x27 but zero sometimes when I don't think it should be
+    12 => {
+        Name => 'FlashFocalLength',
+        Notes => 'only valid if flash pattern is "Standard Illumination"',
+        RawConv => '($val and $val != 255) ? $val : undef',
+        PrintConv => '"$val mm"',
+        PrintConvInv => '$val=~/(\d+)/; $1 || 0',
+    },
+    13 => {
+        Name => 'RepeatingFlashRate',
+        RawConv => '($val and $val != 255) ? $val : undef',
+        PrintConv => '"$val Hz"',
+        PrintConvInv => '$val=~/(\d+)/; $1 || 0',
+    },
+    14 => {
+        Name => 'RepeatingFlashCount',
+        RawConv => '($val and $val != 255) ? $val : undef',
+    },
+    15 => { # (NC)
+        Name => 'FlashGNDistance',
+        SeparateTable => 1,
+        PrintConv => \%flashGNDistance,
+    },
+    16 => {
+        Name => 'FlashColorFilter',
+        SeparateTable => 1,
+        PrintConv => \%flashColorFilter,
+    },
+    17.1 => {
+        Name => 'FlashGroupAControlMode',
+        Mask => 0x0f,
+        DataMember => 'FlashGroupAControlMode',
+        RawConv => '$$self{FlashGroupAControlMode} = $val',
+        PrintConv => \%flashControlMode,
+        SeparateTable => 'FlashControlMode',
+    },
+    18.1 => {
+        Name => 'FlashGroupBControlMode',
+        Mask => 0xf0,
+        DataMember => 'FlashGroupBControlMode',
+        RawConv => '$$self{FlashGroupBControlMode} = $val',
+        PrintConv => \%flashControlMode,
+        SeparateTable => 'FlashControlMode',
+    },
+    18.2 => {
+        Name => 'FlashGroupCControlMode',
+        Mask => 0x0f,
+        DataMember => 'FlashGroupCControlMode',
+        RawConv => '$$self{FlashGroupCControlMode} = $val',
+        PrintConv => \%flashControlMode,
+        SeparateTable => 'FlashControlMode',
+    },
+  # 0x13 - same as 0x28 but not zero when flash group A is Off
+  # 0x14 - same as 0x29 but not zero when flash group B is Off
+  # 0x15 - same as 0x2a but not zero when flash group B is Off
+  # 0x1a - changes with illumination pattern (0=normal,1=narrow,2=wide), but other values seen
+  # 0x26 - changes when diffuser is used
+    0x27 => [
+        {
+            Name => 'FlashOutput',
+            Condition => '$$self{FlashControlMode} >= 0x06',
+            ValueConv => '2 ** (-$val/6)',
+            ValueConvInv => '$val>0 ? -6*log($val)/log(2) : 0',
+            PrintConv => '$val>0.99 ? "Full" : sprintf("%.0f%%",$val*100)',
+            PrintConvInv => '$val=~/(\d+)/ ? $1/100 : 1',
+        },
+        {
+            Name => 'FlashCompensation',
+            Format => 'int8s',
+            Priority => 0,
+            ValueConv => '-$val/6',
+            ValueConvInv => '-6 * $val',
+            PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
+            PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+        },
+    ],
+    0x28 => [
+        {
+            Name => 'FlashGroupAOutput',
+            Condition => '$$self{FlashGroupAControlMode} >= 0x06',
+            ValueConv => '2 ** (-$val/6)',
+            ValueConvInv => '$val>0 ? -6*log($val)/log(2) : 0',
+            PrintConv => '$val>0.99 ? "Full" : sprintf("%.0f%%",$val*100)',
+            PrintConvInv => '$val=~/(\d+)/ ? $1/100 : 1',
+        },
+        {
+            Name => 'FlashGroupACompensation',
+            Format => 'int8s',
+            ValueConv => '-$val/6',
+            ValueConvInv => '-6 * $val',
+            PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+            PrintConvInv => '$val',
+        },
+    ],
+    0x29 => [
+        {
+            Name => 'FlashGroupBOutput',
+            Condition => '$$self{FlashGroupBControlMode} >= 0x60',
+            ValueConv => '2 ** (-$val/6)',
+            ValueConvInv => '$val>0 ? -6*log($val)/log(2) : 0',
+            PrintConv => '$val>0.99 ? "Full" : sprintf("%.0f%%",$val*100)',
+            PrintConvInv => '$val=~/(\d+)/ ? $1/100 : 1',
+        },
+        {
+            Name => 'FlashGroupBCompensation',
+            Format => 'int8s',
+            ValueConv => '-$val/6',
+            ValueConvInv => '-6 * $val',
+            PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+            PrintConvInv => '$val',
+        },
+    ],
+    0x2a => [
+        {
+            Name => 'FlashGroupCOutput',
+            Condition => '$$self{FlashGroupCControlMode} >= 0x06',
+            ValueConv => '2 ** (-$val/6)',
+            ValueConvInv => '$val>0 ? -6*log($val)/log(2) : 0',
+            PrintConv => '$val>0.99 ? "Full" : sprintf("%.0f%%",$val*100)',
+            PrintConvInv => '$val=~/(\d+)/ ? $1/100 : 1',
+        },
+        {
+            Name => 'FlashGroupCCompensation',
+            Format => 'int8s',
+            ValueConv => '-$val/6',
+            ValueConvInv => '-6 * $val',
+            PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+            PrintConvInv => '$val',
+        },
+    ],
+);
+
+# Flash information for the D4S/D750/D810/D5500/D7200 (0107)
+# and D5/D500/D850/D3400 (0108) (ref 28)
+%Image::ExifTool::Nikon::FlashInfo0107 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    DATAMEMBER => [ 17.1, 18.1, 18.2 ],
+    NOTES => q{
+        These tags are used by the D4S, D750, D810, D5500, D7200 (FlashInfoVersion
+        0107) and the D5, D500, D850 and D3400 (FlashInfoVersion 0108).
+    },
+    # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
+    0 => {
+        Name => 'FlashInfoVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    4 => {
+        Name => 'FlashSource',
+        PrintConv => {
+            0 => 'None',
+            1 => 'External',
+            2 => 'Internal',
+        },
+    },
+    6 => {
+        Format => 'int8u[2]',
+        Name => 'ExternalFlashFirmware',
+        SeparateTable => 'FlashFirmware',
+        PrintConv => \%flashFirmware,
+    },
+    8.1 => {
+        Name => 'ExternalFlashZoomOverride',
+        Mask => 0x80,
+        Notes => 'indicates that the user has overridden the flash zoom distance',
+        PrintConv => { 0 => 'No', 1 => 'Yes' },
+    },
+    8.2 => {
+        Name => 'ExternalFlashStatus',
+        Mask => 0x01,
+        PrintConv => {
+            0 => 'Flash Not Attached',
+            1 => 'Flash Attached',
+        },
+    },
+    9.1 => {
+        Name => 'ExternalFlashReadyState',
+        Mask => 0x07,
+        PrintConv => {
+            0 => 'n/a',
+            1 => 'Ready',
+            6 => 'Not Ready',
+        },
+    },
+    10 => {
+        Name => 'FlashCompensation',
+        # this is the compensation from the camera (0x0012) for "Built-in" FlashType, or
+        # the compensation from the external unit (0x0017) for "Optional" FlashType - PH
+        Format => 'int8s',
+        Priority => 0,
+        ValueConv => '-$val/6',
+        ValueConvInv => '-6 * $val',
+        PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    12 => {
+        Name => 'FlashFocalLength',
+        Notes => 'only valid if flash pattern is "Standard Illumination"',
+        RawConv => '($val and $val != 255) ? $val : undef',
+        PrintConv => '"$val mm"',
+        PrintConvInv => '$val=~/(\d+)/; $1 || 0',
+    },
+    13 => {
+        Name => 'RepeatingFlashRate',
+        RawConv => '($val and $val != 255) ? $val : undef',
+        PrintConv => '"$val Hz"',
+        PrintConvInv => '$val=~/(\d+)/; $1 || 0',
+    },
+    14 => {
+        Name => 'RepeatingFlashCount',
+        RawConv => '($val and $val != 255) ? $val : undef',
+    },
+    15 => {
+        Name => 'FlashGNDistance',
+        SeparateTable => 1,
+        PrintConv => \%flashGNDistance,
+    },
+    17.1 => { #PH
+        Name => 'FlashGroupAControlMode',
+        Mask => 0x0f,
+        Notes => 'note: group A tags may apply to the built-in flash settings for some models',
+        DataMember => 'FlashGroupAControlMode',
+        RawConv => '$$self{FlashGroupAControlMode} = $val',
+        PrintConv => \%flashControlMode,
+        SeparateTable => 'FlashControlMode',
+    },
+    18.1 => { #PH
+        Name => 'FlashGroupBControlMode',
+        Mask => 0xf0,
+        Notes => 'note: group B tags may apply to group A settings for some models',
+        DataMember => 'FlashGroupBControlMode',
+        RawConv => '$$self{FlashGroupBControlMode} = $val',
+        PrintConv => \%flashControlMode,
+        SeparateTable => 'FlashControlMode',
+    },
+    18.2 => { #PH
+        Name => 'FlashGroupCControlMode',
+        Mask => 0x0f,
+        Notes => 'note: group C tags may apply to group B settings for some models',
+        DataMember => 'FlashGroupCControlMode',
+        RawConv => '$$self{FlashGroupCControlMode} = $val',
+        PrintConv => \%flashControlMode,
+        SeparateTable => 'FlashControlMode',
+    },
+    # 0x13 - very similar to 0x28
+    # 0x18 or 0x19 may indicate flash illumination pattern (Standard, Center-weighted, Even)
+    0x28 => [ #PH
+        {
+            Name => 'FlashGroupAOutput',
+            Condition => '$$self{FlashGroupAControlMode} >= 0x06',
+            ValueConv => '2 ** (-$val/6)',
+            ValueConvInv => '$val>0 ? -6*log($val)/log(2) : 0',
+            PrintConv => '$val>0.99 ? "Full" : sprintf("%.0f%%",$val*100)',
+            PrintConvInv => '$val=~/(\d+)/ ? $1/100 : 1',
+        },
+        {
+            Name => 'FlashGroupACompensation',
+            Format => 'int8s',
+            ValueConv => '-$val/6',
+            ValueConvInv => '-6 * $val',
+            PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+            PrintConvInv => '$val',
+        },
+    ],
+    0x29 => [ #PH
+        {
+            Name => 'FlashGroupBOutput',
+            Condition => '$$self{FlashGroupBControlMode} >= 0x60',
+            ValueConv => '2 ** (-$val/6)',
+            ValueConvInv => '$val>0 ? -6*log($val)/log(2) : 0',
+            PrintConv => '$val>0.99 ? "Full" : sprintf("%.0f%%",$val*100)',
+            PrintConvInv => '$val=~/(\d+)/ ? $1/100 : 1',
+        },
+        {
+            Name => 'FlashGroupBCompensation',
+            Format => 'int8s',
+            ValueConv => '-$val/6',
+            ValueConvInv => '-6 * $val',
+            PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+            PrintConvInv => '$val',
+        },
+    ],
+    0x2a => [ #PH
+        {
+            Name => 'FlashGroupCOutput',
+            Condition => '$$self{FlashGroupCControlMode} >= 0x06',
+            ValueConv => '2 ** (-$val/6)',
+            ValueConvInv => '$val>0 ? -6*log($val)/log(2) : 0',
+            PrintConv => '$val>0.99 ? "Full" : sprintf("%.0f%%",$val*100)',
+            PrintConvInv => '$val=~/(\d+)/ ? $1/100 : 1',
+        },
+        {
+            Name => 'FlashGroupCCompensation',
+            Format => 'int8s',
+            ValueConv => '-$val/6',
+            ValueConvInv => '-6 * $val',
+            PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+            PrintConvInv => '$val',
+        },
+    ],
+);
+
+# Flash information for the Z7_2 (ref 28)
+# (likey similar to FlashInfo010 and FlashInfo0108 with addition of support for radio controlled units such as the SB-5000?
+%Image::ExifTool::Nikon::FlashInfo0300 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0 => {
+        Name => 'FlashInfoVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    4 => {
+        Name => 'FlashSource',
+        PrintConv => {
+            0 => 'None',
+            1 => 'External',
+            2 => 'Internal',
+        },
+    },
+    6 => {
+        Format => 'int8u[2]',
+        Name => 'ExternalFlashFirmware',
+        SeparateTable => 'FlashFirmware',
+        PrintConv => \%flashFirmware,
+    },
+    27 => {
+        Name => 'FlashCompensation',
+        # this is the compensation from the camera (0x0012) for "Built-in" FlashType, or
+        # the compensation from the external unit (0x0017) for "Optional" FlashType - PH
+        Format => 'int8s',
+        Priority => 0,
+        ValueConv => '-$val/6',
+        ValueConvInv => '-6 * $val',
+        PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+);
 # Unknown Flash information
 %Image::ExifTool::Nikon::FlashInfoUnknown = (
@@ -4264,5 +8373,4 @@
     FORMAT => 'int32u',
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
     0 => {
         Name => 'MultiExposureVersion',
@@ -4276,4 +8384,5 @@
             1 => 'Multiple Exposure',
             2 => 'Image Overlay',
+            3 => 'HDR', #31
         },
     },
@@ -4283,4 +8392,108 @@
         PrintConv => \%offOn,
     },
+);
+
+# HDR information (ref 32)
+%Image::ExifTool::Nikon::HDRInfo = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
+    0 => {
+        Name => 'HDRInfoVersion',
+        Format => 'string[4]',
+    },
+    4 => {
+        Name => 'HDR',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+            48 => 'Auto', #PH (NC)
+        },
+    },
+    5 => {
+        Name => 'HDRLevel',
+        PrintConv => {
+            0 => 'Auto',
+            1 => '1 EV',
+            2 => '2 EV',
+            3 => '3 EV',
+            # 5 - seen for 1J4
+            255 => 'n/a', #PH
+        },
+    },
+    6 => {
+        Name => 'HDRSmoothing',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Normal',
+            2 => 'Low',
+            3 => 'High',
+            48 => 'Auto', #PH (NC)
+            255 => 'n/a', #PH
+        },
+    },
+    7 => { #PH (P330, HDRInfoVersion=0101)
+        Name => 'HDRLevel2',
+        PrintConv => {
+            0 => 'Auto',
+            1 => '1 EV',
+            2 => '2 EV',
+            3 => '3 EV',
+            255 => 'n/a',
+        },
+    },
+);
+
+# location information (ref PH)
+%Image::ExifTool::Nikon::LocationInfo = (
+    %binaryDataAttrs,
+    DATAMEMBER => [ 4 ],
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Location' },
+    NOTES => 'Tags written by some Nikon GPS-equipped cameras like the AW100.',
+    0 => {
+        Name => 'LocationInfoVersion',
+        Format => 'undef[4]',
+    },
+    4 => {
+        Name => 'TextEncoding',
+        DataMember => 'TextEncoding',
+        RawConv => q{
+            $$self{TextEncoding} = $Image::ExifTool::Nikon::nikonTextEncoding{$val} if $val;
+            return $val;
+        },
+        PrintConv => \%Image::ExifTool::Nikon::nikonTextEncoding,
+    },
+    # (the CountryCode and Location tag names chosen to correspond with XMP::iptcCore)
+    5 => {
+        Name => 'CountryCode',
+        Format => 'undef[3]',
+        ValueConv => '$val=~s/\0.*//s; $val', # truncate at null
+        ValueConvInv => '$val',
+    },
+    8 => 'POILevel', #forum5782
+    9 => {
+        Name => 'Location',
+        Format => 'undef[70]',
+        RawConv    => '$$self{TextEncoding} ? $self->Decode($val,$$self{TextEncoding},"MM") : $val',
+        RawConvInv => '$$self{TextEncoding} ? $self->Encode($val,$$self{TextEncoding},"MM") : $val',
+    },
+);
+
+# extra info found in IFD0 of NEF files (ref PH, Z6/Z7)
+%Image::ExifTool::Nikon::NEFInfo = (
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        As-yet unknown information found in SubIFD1 tag 0xc7d5 of NEF images from
+        cameras such as the Z6 and Z7, and NRW images from some Coolpix cameras.
+    },
+    # 0x01 - undef[12]
+    # 0x02 - undef[148]
+    # 0x03 - undef[284]
+    # 0x04 - undef[148,212]
+    # 0x05 - undef[84]
+    # 0x06 - undef[116]
+    # 0x07 - undef[104]
+    # 0x08 - undef[24]
+    # 0x09 - undef[36]
 );
 
@@ -4358,4 +8571,5 @@
     ncth => {
         Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
         Binary => 1,
     },
@@ -4366,4 +8580,5 @@
     ncvw => {
         Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
         RawConv => 'length($val) ? $val : undef',
         Binary => 1,
@@ -4542,6 +8757,6 @@
     GROUPS => { 0 => 'MakerNotes', 1 => 'Nikon', 2 => 'Video' },
     NOTES => q{
-        Nikon-specific QuickTime tags found in the NCDT atom of MOV videos from some
-        Nikon cameras such as the Coolpix S8000.
+        Nikon-specific QuickTime tags found in the NCDT atom of MOV videos from
+        various Nikon models.
     },
     NCHD => {
@@ -4558,7 +8773,43 @@
         SubDirectory => { TagTable => 'Image::ExifTool::Nikon::NCTG' },
     },
-    NCTH => { Name => 'ThumbnailImage', Format => 'undef', Binary => 1 },
-    NCVW => { Name => 'PreviewImage',   Format => 'undef', Binary => 1 },
-    # NCDB - 0 bytes long, or 4 null bytes
+    NCTH => {
+        Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef',
+        Binary => 1,
+    },
+    NCVW => {
+        Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef',
+        Binary => 1,
+    },
+    NCDB => { # (often 0 bytes long, or 4 null bytes)
+        Name => 'NikonNCDB',
+        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::NCDB' },
+    },
+    NCM1 => {
+        Name => 'PreviewImage1',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef',
+        Binary => 1,
+        RawConv => 'length $val ? $val : undef',
+    },
+    NCM2 => { #PH (guess - have only seen 0 bytes)
+        Name => 'PreviewImage2',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef',
+        Binary => 1,
+        RawConv => 'length $val ? $val : undef',
+    },
+);
+
+# Nikon NCDB tags from MOV videos (ref PH)
+%Image::ExifTool::Nikon::NCDB = (
+    GROUPS => { 0 => 'MakerNotes', 1 => 'Nikon', 2 => 'Video' },
+    # the following probably contain encrypted data -- look into decryping these!
+    # OP01 - 320 bytes, starts with "0200" (D600,D610,D810,D3200,D5200)
+    #      - 638 bytes, starts with "0200" (D7100)
+    # OP02 - 2048 bytes, starts with "0200" (D810)
 );
 
@@ -4597,4 +8848,10 @@
         PrintConv => 'int($val * 1000 + 0.5) / 1000',
     },
+    # 0x17 - rational62u: same value as FrameRate
+    # 0x18 - int16u: 1, 2
+    0x19 => {
+        Name => 'TimeZone',
+        Groups => { 2 => 'Time' },
+    },
     # 0x21 - int16u: 1, 2
     0x22 => {
@@ -4606,6 +8863,6 @@
         Groups => { 2 => 'Video' },
     },
-    # 0x24 - int16u: 2
-    # 0x31 - int16u: 1, 2
+    # 0x24 - int16u: 1, 2
+    # 0x31 - int16u: 0, 1, 2
     0x32 => { #(guess)
         Name => 'AudioChannels',
@@ -4620,4 +8877,169 @@
         Groups => { 2 => 'Audio' },
     },
+    # 0x101 - int16u[4]: "160 120 1280 720", "160 120 3840 2160"
+    # 0x102 - int16u[8]: "640 360 0 0 0 0 0 0", "640 360 1920 1080 0 0 0 0"
+    # 0x1001 - int16s: 0
+    0x1002 => {
+        Name => 'NikonDateTime', #?
+        Groups => { 2 => 'Time' },
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    # 0x1011 - int32u: 0
+    # 0x1012 - int32u: 0
+    0x1013 => { #HayoBaan
+        Name => 'ElectronicVR',
+        PrintConv => \%offOn,
+    },
+    # 0x1014 - int16u: 1
+    # 0x1021 - int32u[32]: all zeros
+#
+# 0x110**** tags correspond to 0x**** tags in Exif::Main
+#
+    0x110829a => { #34
+        Name => 'ExposureTime',
+        PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+    },
+    0x110829d => { #34
+        Name => 'FNumber',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+    },
+    0x1108822 => {
+        Name => 'ExposureProgram',
+        PrintConv => {
+            0 => 'Not Defined',
+            1 => 'Manual',
+            2 => 'Program AE',
+            3 => 'Aperture-priority AE',
+            4 => 'Shutter speed priority AE',
+            5 => 'Creative (Slow speed)',
+            6 => 'Action (High speed)',
+            7 => 'Portrait',
+            8 => 'Landscape',
+          # 9 => 'Bulb', # (non-standard Canon value)
+        },
+    },
+    0x1109204 => {
+        Name => 'ExposureCompensation',
+        PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
+    },
+    0x1109207 => {
+        Name => 'MeteringMode',
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Average',
+            2 => 'Center-weighted average',
+            3 => 'Spot',
+            4 => 'Multi-spot',
+            5 => 'Multi-segment',
+            6 => 'Partial',
+            255 => 'Other',
+        },
+    },
+    0x110920a => { #34
+        Name => 'FocalLength',
+        PrintConv => 'sprintf("%.1f mm",$val)',
+    },
+    0x110a431 => 'SerialNumber',
+    0x110a432 => {
+        Name => 'LensInfo',
+        PrintConv => \&Image::ExifTool::Exif::PrintLensInfo,
+    },
+    0x110a433 => 'LensMake',
+    0x110a434 => 'LensModel',
+    0x110a435 => 'LensSerialNumber',
+#
+# 0x120**** tags correspond to 0x**** tags in GPS::Main
+#
+    0x1200000 => {
+        Name => 'GPSVersionID',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => '$val =~ tr/ /./; $val',
+    },
+    0x1200001 => {
+        Name => 'GPSLatitudeRef',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            N => 'North',
+            S => 'South',
+        },
+    },
+    0x1200002 => {
+        Name => 'GPSLatitude',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        ValueConv => q{
+            require Image::ExifTool::GPS;
+            Image::ExifTool::GPS::ToDegrees($val);
+        },
+        PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1)',
+    },
+    0x1200003 => {
+        Name => 'GPSLongitudeRef',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            E => 'East',
+            W => 'West',
+        },
+    },
+    0x1200004 => {
+        Name => 'GPSLongitude',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        ValueConv => q{
+            require Image::ExifTool::GPS;
+            Image::ExifTool::GPS::ToDegrees($val);
+        },
+        PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1)',
+    },
+    0x1200005 => {
+        Name => 'GPSAltitudeRef',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            0 => 'Above Sea Level',
+            1 => 'Below Sea Level',
+        },
+    },
+    0x1200006 => {
+        Name => 'GPSAltitude',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => '$val =~ /^(inf|undef)$/ ? $val : "$val m"',
+    },
+    0x1200007 => {
+        Name => 'GPSTimeStamp',
+        Groups => { 1 => 'GPS', 2 => 'Time' },
+        ValueConv => q{
+            require Image::ExifTool::GPS;
+            Image::ExifTool::GPS::ConvertTimeStamp($val);
+        },
+        PrintConv => 'Image::ExifTool::GPS::PrintTimeStamp($val)',
+    },
+    0x1200008 => {
+        Name => 'GPSSatellites',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+    },
+    0x1200010 => {
+        Name => 'GPSImgDirectionRef',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            M => 'Magnetic North',
+            T => 'True North',
+        },
+    },
+    0x1200011 => {
+        Name => 'GPSImgDirection',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+    },
+    0x1200012 => {
+        Name => 'GPSMapDatum',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+    },
+    0x120001d => {
+        Name => 'GPSDateStamp',
+        Groups => { 1 => 'GPS', 2 => 'Time' },
+        ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
+    },
+#
+# 0x200**** tags correspond to 0x**** tags in Nikon::Main
+# (must be duplicated here so tagInfo "Table" entry will point to correct table.
+#  Also there would be a problem with the PRINT_CONV from the Main table)
+#
     0x2000001 => {
         Name => 'MakerNoteVersion',
@@ -4625,5 +9047,12 @@
     },
     0x2000005 => 'WhiteBalance',
+    0x2000007 => { Name => 'FocusMode',    Writable => 'string' }, #34
     0x200000b => 'WhiteBalanceFineTune',
+    0x200001b => {
+        Name => 'CropHiSpeed',
+        Writable => 'int16u',
+        Count => 7,
+        PrintConv => \%cropHiSpeed,
+    },
     0x200001e => {
         Name => 'ColorSpace',
